searchNodes=[{"type":"module","title":"Exqlite","doc":"SQLite3 driver for Elixir.","ref":"Exqlite.html"},{"type":"function","title":"Exqlite.child_spec/1","doc":"","ref":"Exqlite.html#child_spec/1"},{"type":"function","title":"Exqlite.close/3","doc":"","ref":"Exqlite.html#close/3"},{"type":"function","title":"Exqlite.close!/3","doc":"","ref":"Exqlite.html#close!/3"},{"type":"function","title":"Exqlite.execute/4","doc":"","ref":"Exqlite.html#execute/4"},{"type":"function","title":"Exqlite.execute!/4","doc":"","ref":"Exqlite.html#execute!/4"},{"type":"function","title":"Exqlite.prepare/4","doc":"","ref":"Exqlite.html#prepare/4"},{"type":"function","title":"Exqlite.prepare!/4","doc":"","ref":"Exqlite.html#prepare!/4"},{"type":"function","title":"Exqlite.prepare_execute/5","doc":"","ref":"Exqlite.html#prepare_execute/5"},{"type":"function","title":"Exqlite.prepare_execute!/5","doc":"","ref":"Exqlite.html#prepare_execute!/5"},{"type":"function","title":"Exqlite.query/4","doc":"","ref":"Exqlite.html#query/4"},{"type":"function","title":"Exqlite.query!/4","doc":"","ref":"Exqlite.html#query!/4"},{"type":"function","title":"Exqlite.rollback/2","doc":"","ref":"Exqlite.html#rollback/2"},{"type":"function","title":"Exqlite.start_link/1","doc":"See Exqlite.Connection.connect/1","ref":"Exqlite.html#start_link/1"},{"type":"function","title":"Exqlite.transaction/3","doc":"","ref":"Exqlite.html#transaction/3"},{"type":"module","title":"Exqlite.Basic","doc":"A very basic API for simple use cases.","ref":"Exqlite.Basic.html"},{"type":"function","title":"Exqlite.Basic.close/1","doc":"","ref":"Exqlite.Basic.html#close/1"},{"type":"function","title":"Exqlite.Basic.disable_load_extension/1","doc":"","ref":"Exqlite.Basic.html#disable_load_extension/1"},{"type":"function","title":"Exqlite.Basic.enable_load_extension/1","doc":"","ref":"Exqlite.Basic.html#enable_load_extension/1"},{"type":"function","title":"Exqlite.Basic.exec/3","doc":"","ref":"Exqlite.Basic.html#exec/3"},{"type":"function","title":"Exqlite.Basic.load_extension/2","doc":"","ref":"Exqlite.Basic.html#load_extension/2"},{"type":"function","title":"Exqlite.Basic.open/1","doc":"","ref":"Exqlite.Basic.html#open/1"},{"type":"function","title":"Exqlite.Basic.rows/1","doc":"","ref":"Exqlite.Basic.html#rows/1"},{"type":"module","title":"Exqlite.Connection","doc":"This module implements connection details as defined in DBProtocol. Attributes db - The sqlite3 database reference. path - The path that was used to open. transaction_status - The status of the connection. Can be :idle or :transaction . Unknowns How are pooled connections going to work? Since sqlite3 doesn't allow for simultaneous access. We would need to check if the write ahead log is enabled on the database. We can't assume and set the WAL pragma because the database may be stored on a network volume which would cause potential issues. Notes: we try to closely follow structure and naming convention of myxql. sqlite thrives when there are many small conventions, so we may not implement some strategies employed by other adapters. See https://sqlite.org/np1queryprob.html","ref":"Exqlite.Connection.html"},{"type":"function","title":"Exqlite.Connection.connect/1","doc":"Initializes the Ecto Exqlite adapter. For connection configurations we use the defaults that come with SQLite3, but we recommend which options to choose. We do not default to the recommended because we don't know what your environment is like. Allowed options: :database - The path to the database. In memory is allowed. You can use :memory or &quot;:memory:&quot; to designate that. :mode - use :readwrite to open the database for reading and writing or :readonly to open it in read-only mode. :readwrite will also create the database if it doesn't already exist. Defaults to :readwrite . :journal_mode - Sets the journal mode for the sqlite connection. Can be one of the following :delete , :truncate , :persist , :memory , :wal , or :off . Defaults to :delete . It is recommended that you use :wal due to support for concurrent reads. Note: :wal does not mean concurrent writes. :temp_store - Sets the storage used for temporary tables. Default is :default . Allowed values are :default , :file , :memory . It is recommended that you use :memory for storage. :synchronous - Can be :extra , :full , :normal , or :off . Defaults to :normal . :foreign_keys - Sets if foreign key checks should be enforced or not. Can be :on or :off . Default is :on . :cache_size - Sets the cache size to be used for the connection. This is an odd setting as a positive value is the number of pages in memory to use and a negative value is the size in kilobytes to use. Default is -2000 . It is recommended that you use -64000 . :cache_spill - The cache_spill pragma enables or disables the ability of the pager to spill dirty cache pages to the database file in the middle of a transaction. By default it is :on , and for most applications, it should remain so. :case_sensitive_like :auto_vacuum - Defaults to :none . Can be :none , :full or :incremental . Depending on the database size, :incremental may be beneficial. :locking_mode - Defaults to :normal . Allowed values are :normal or :exclusive . See sqlite documentation for more information. :secure_delete - Defaults to :off . If enabled, it will cause SQLite3 to overwrite records that were deleted with zeros. :wal_auto_check_point - Sets the write-ahead log auto-checkpoint interval. Default is 1000 . Setting the auto-checkpoint size to zero or a negative value turns auto-checkpointing off. :busy_timeout - Sets the busy timeout in milliseconds for a connection. Default is 2000 . :chunk_size - The chunk size for bulk fetching. Defaults to 50 . :key - Optional key to set during database initialization. This PRAGMA is often used to set up database level encryption. :journal_size_limit - The size limit in bytes of the journal. :soft_heap_limit - The size limit in bytes for the heap limit. :hard_heap_limit - The size limit in bytes for the heap. :custom_pragmas - A list of custom pragmas to set on the connection, for example to configure extensions. :load_extensions - A list of paths identifying extensions to load. Defaults to [] . The provided list will be merged with the global extensions list, set on :exqlite, :load_extensions . Be aware that the path should handle pointing to a library compiled for the current architecture. Example configuration: arch_dir = System . cmd ( &quot;uname&quot; , [ &quot;-sm&quot; ] ) |&gt; elem ( 0 ) |&gt; String . trim ( ) |&gt; String . replace ( &quot; &quot; , &quot;-&quot; ) |&gt; String . downcase ( ) # =&gt; &quot;darwin-arm64&quot; config :myapp , arch_dir : arch_dir # global config :exqlite , load_extensions : [ &quot;./priv/sqlite/ \#{ arch_dir } /rotate&quot; ] # per connection in a Phoenix app config :myapp , Myapp.Repo , database : &quot;path/to/db&quot; , load_extensions : [ &quot;./priv/sqlite/ \#{ arch_dir } /vector0&quot; , &quot;./priv/sqlite/ \#{ arch_dir } /vss0&quot; ] For more information about the options above, see sqlite documentation","ref":"Exqlite.Connection.html#connect/1"},{"type":"function","title":"Exqlite.Connection.handle_begin/2","doc":"Begin a transaction. For full info refer to sqlite docs: https://sqlite.org/lang_transaction.html Note: default transaction mode is DEFERRED.","ref":"Exqlite.Connection.html#handle_begin/2"},{"type":"function","title":"Exqlite.Connection.handle_close/3","doc":"Close a query prepared by handle_prepare/3 with the database. Return {:ok, result, state} on success and to continue, {:error, exception, state} to return an error and continue, or {:disconnect, exception, state} to return an error and disconnect. This callback is called in the client process.","ref":"Exqlite.Connection.html#handle_close/3"},{"type":"function","title":"Exqlite.Connection.maybe_put_command/2","doc":"","ref":"Exqlite.Connection.html#maybe_put_command/2"},{"type":"type","title":"Exqlite.Connection.auto_vacuum/0","doc":"","ref":"Exqlite.Connection.html#t:auto_vacuum/0"},{"type":"type","title":"Exqlite.Connection.connection_opt/0","doc":"","ref":"Exqlite.Connection.html#t:connection_opt/0"},{"type":"type","title":"Exqlite.Connection.journal_mode/0","doc":"","ref":"Exqlite.Connection.html#t:journal_mode/0"},{"type":"type","title":"Exqlite.Connection.locking_mode/0","doc":"","ref":"Exqlite.Connection.html#t:locking_mode/0"},{"type":"type","title":"Exqlite.Connection.synchronous/0","doc":"","ref":"Exqlite.Connection.html#t:synchronous/0"},{"type":"type","title":"Exqlite.Connection.t/0","doc":"","ref":"Exqlite.Connection.html#t:t/0"},{"type":"type","title":"Exqlite.Connection.temp_store/0","doc":"","ref":"Exqlite.Connection.html#t:temp_store/0"},{"type":"module","title":"Exqlite.Pragma","doc":"Handles parsing extra options for the SQLite connection","ref":"Exqlite.Pragma.html"},{"type":"function","title":"Exqlite.Pragma.auto_vacuum/1","doc":"","ref":"Exqlite.Pragma.html#auto_vacuum/1"},{"type":"function","title":"Exqlite.Pragma.busy_timeout/1","doc":"","ref":"Exqlite.Pragma.html#busy_timeout/1"},{"type":"function","title":"Exqlite.Pragma.cache_size/1","doc":"","ref":"Exqlite.Pragma.html#cache_size/1"},{"type":"function","title":"Exqlite.Pragma.cache_spill/1","doc":"","ref":"Exqlite.Pragma.html#cache_spill/1"},{"type":"function","title":"Exqlite.Pragma.case_sensitive_like/1","doc":"","ref":"Exqlite.Pragma.html#case_sensitive_like/1"},{"type":"function","title":"Exqlite.Pragma.foreign_keys/1","doc":"","ref":"Exqlite.Pragma.html#foreign_keys/1"},{"type":"function","title":"Exqlite.Pragma.journal_mode/1","doc":"","ref":"Exqlite.Pragma.html#journal_mode/1"},{"type":"function","title":"Exqlite.Pragma.locking_mode/1","doc":"","ref":"Exqlite.Pragma.html#locking_mode/1"},{"type":"function","title":"Exqlite.Pragma.secure_delete/1","doc":"","ref":"Exqlite.Pragma.html#secure_delete/1"},{"type":"function","title":"Exqlite.Pragma.synchronous/1","doc":"","ref":"Exqlite.Pragma.html#synchronous/1"},{"type":"function","title":"Exqlite.Pragma.temp_store/1","doc":"","ref":"Exqlite.Pragma.html#temp_store/1"},{"type":"function","title":"Exqlite.Pragma.wal_auto_check_point/1","doc":"","ref":"Exqlite.Pragma.html#wal_auto_check_point/1"},{"type":"module","title":"Exqlite.Query","doc":"Query struct returned from a successfully prepared query.","ref":"Exqlite.Query.html"},{"type":"function","title":"Exqlite.Query.build/1","doc":"","ref":"Exqlite.Query.html#build/1"},{"type":"type","title":"Exqlite.Query.t/0","doc":"","ref":"Exqlite.Query.html#t:t/0"},{"type":"module","title":"Exqlite.Result","doc":"The database results.","ref":"Exqlite.Result.html"},{"type":"function","title":"Exqlite.Result.new/1","doc":"","ref":"Exqlite.Result.html#new/1"},{"type":"type","title":"Exqlite.Result.t/0","doc":"","ref":"Exqlite.Result.html#t:t/0"},{"type":"module","title":"Exqlite.Sqlite3","doc":"The interface to the NIF implementation.","ref":"Exqlite.Sqlite3.html"},{"type":"function","title":"Exqlite.Sqlite3.bind/3","doc":"","ref":"Exqlite.Sqlite3.html#bind/3"},{"type":"function","title":"Exqlite.Sqlite3.changes/1","doc":"Get the number of changes recently. Note : If triggers are used, the count may be larger than expected. See: https://sqlite.org/c3ref/changes.html","ref":"Exqlite.Sqlite3.html#changes/1"},{"type":"function","title":"Exqlite.Sqlite3.close/1","doc":"Closes the database and releases any underlying resources.","ref":"Exqlite.Sqlite3.html#close/1"},{"type":"function","title":"Exqlite.Sqlite3.columns/2","doc":"","ref":"Exqlite.Sqlite3.html#columns/2"},{"type":"function","title":"Exqlite.Sqlite3.deserialize/3","doc":"Disconnect from database and then reopen as an in-memory database based on the serialized binary.","ref":"Exqlite.Sqlite3.html#deserialize/3"},{"type":"function","title":"Exqlite.Sqlite3.enable_load_extension/2","doc":"Allow loading native extensions.","ref":"Exqlite.Sqlite3.html#enable_load_extension/2"},{"type":"function","title":"Exqlite.Sqlite3.execute/2","doc":"Executes an sql script. Multiple stanzas can be passed at once.","ref":"Exqlite.Sqlite3.html#execute/2"},{"type":"function","title":"Exqlite.Sqlite3.fetch_all/2","doc":"","ref":"Exqlite.Sqlite3.html#fetch_all/2"},{"type":"function","title":"Exqlite.Sqlite3.fetch_all/3","doc":"","ref":"Exqlite.Sqlite3.html#fetch_all/3"},{"type":"function","title":"Exqlite.Sqlite3.last_insert_rowid/1","doc":"","ref":"Exqlite.Sqlite3.html#last_insert_rowid/1"},{"type":"function","title":"Exqlite.Sqlite3.multi_step/2","doc":"","ref":"Exqlite.Sqlite3.html#multi_step/2"},{"type":"function","title":"Exqlite.Sqlite3.multi_step/3","doc":"","ref":"Exqlite.Sqlite3.html#multi_step/3"},{"type":"function","title":"Exqlite.Sqlite3.open/2","doc":"Opens a new sqlite database at the Path provided. path can be &quot;:memory&quot; to keep the sqlite database in memory. Options :mode - use :readwrite to open the database for reading and writing or :readonly to open it in read-only mode. :readwrite will also create the database if it doesn't already exist. Defaults to :readwrite .","ref":"Exqlite.Sqlite3.html#open/2"},{"type":"function","title":"Exqlite.Sqlite3.prepare/2","doc":"","ref":"Exqlite.Sqlite3.html#prepare/2"},{"type":"function","title":"Exqlite.Sqlite3.release/2","doc":"Once finished with the prepared statement, call this to release the underlying resources. This should be called whenever you are done operating with the prepared statement. If the system has a high load the garbage collector may not clean up the prepared statements in a timely manner and causing higher than normal levels of memory pressure. If you are operating on limited memory capacity systems, definitely call this.","ref":"Exqlite.Sqlite3.html#release/2"},{"type":"function","title":"Exqlite.Sqlite3.serialize/2","doc":"Serialize the contents of the database to a binary.","ref":"Exqlite.Sqlite3.html#serialize/2"},{"type":"function","title":"Exqlite.Sqlite3.shrink_memory/1","doc":"Causes the database connection to free as much memory as it can. This is useful if you are on a memory restricted system.","ref":"Exqlite.Sqlite3.html#shrink_memory/1"},{"type":"function","title":"Exqlite.Sqlite3.step/2","doc":"","ref":"Exqlite.Sqlite3.html#step/2"},{"type":"function","title":"Exqlite.Sqlite3.transaction_status/1","doc":"","ref":"Exqlite.Sqlite3.html#transaction_status/1"},{"type":"type","title":"Exqlite.Sqlite3.db/0","doc":"","ref":"Exqlite.Sqlite3.html#t:db/0"},{"type":"type","title":"Exqlite.Sqlite3.open_opt/0","doc":"","ref":"Exqlite.Sqlite3.html#t:open_opt/0"},{"type":"type","title":"Exqlite.Sqlite3.reason/0","doc":"","ref":"Exqlite.Sqlite3.html#t:reason/0"},{"type":"type","title":"Exqlite.Sqlite3.row/0","doc":"","ref":"Exqlite.Sqlite3.html#t:row/0"},{"type":"type","title":"Exqlite.Sqlite3.statement/0","doc":"","ref":"Exqlite.Sqlite3.html#t:statement/0"},{"type":"module","title":"Exqlite.Sqlite3NIF","doc":"This is the module where all of the NIF entry points reside. Calling this directly should be avoided unless you are aware of what you are doing.","ref":"Exqlite.Sqlite3NIF.html"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.changes/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#changes/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.close/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#close/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.columns/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#columns/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.deserialize/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#deserialize/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.enable_load_extension/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#enable_load_extension/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.execute/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#execute/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.last_insert_rowid/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#last_insert_rowid/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.load_nif/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#load_nif/0"},{"type":"function","title":"Exqlite.Sqlite3NIF.multi_step/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#multi_step/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.open/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#open/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.prepare/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#prepare/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.release/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#release/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.serialize/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#serialize/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.step/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#step/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.transaction_status/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#transaction_status/1"},{"type":"type","title":"Exqlite.Sqlite3NIF.db/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:db/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.reason/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:reason/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.row/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:row/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.statement/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:statement/0"},{"type":"exception","title":"Exqlite.Error","doc":"The error emitted from SQLite or a general error with the library.","ref":"Exqlite.Error.html"},{"type":"type","title":"Exqlite.Error.t/0","doc":"","ref":"Exqlite.Error.html#t:t/0"},{"type":"extras","title":"Readme","doc":"An Elixir SQLite3 library. If you are looking for the Ecto adapter, take a look at the Ecto SQLite3 library . Documentation: https://hexdocs.pm/exqlite Package: https://hex.pm/packages/exqlite","ref":"readme.html"},{"type":"extras","title":"Readme - Caveats","doc":"Prepared statements are not cached. Prepared statements are not immutable. You must be careful when manipulating statements and binding values to statements. Do not try to manipulate the statements concurrently. Keep it isolated to one process. Simultaneous writing is not supported by SQLite3 and will not be supported here. All native calls are run through the Dirty NIF scheduler. Datetimes are stored without offsets. This is due to how SQLite3 handles date and times. If you would like to store a timezone, you will need to create a second column somewhere storing the timezone name and shifting it when you get it from the database. This is more reliable than storing the offset as +03:00 as it does not respect daylight savings time.","ref":"readme.html#caveats"},{"type":"extras","title":"Readme - Installation","doc":"defp deps do [ { :exqlite , &quot;~&gt; 0.13&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Readme - Configuration","doc":"Runtime Configuration config :exqlite , default_chunk_size : 100 default_chunk_size - The chunk size that is used when multi-stepping when not specifying the chunk size explicitly. Compile-time Configuration In config/config.exs , config :exqlite , force_build : false force_build - Set true to opt out of using precompiled artefacts. This option only affects the default configuration. For advanced configuation, this library will always compile natively.","ref":"readme.html#configuration"},{"type":"extras","title":"Readme - Advanced Configuration","doc":"Defining Extra Compile Flags You can enable certain features by doing the following: export EXQLITE_SYSTEM_CFLAGS=-DSQLITE_ENABLE_DBSTAT_VTAB=1 Listing Flags Used For Compilation If you export V=1 the flags used for compilation will be output to stdout. Using System Installed Libraries This will vary depending on the operating system. # tell exqlite that we wish to use some other sqlite installation. this will prevent sqlite3.c and friends from compiling export EXQLITE_USE_SYSTEM=1 # Tell exqlite where to find the `sqlite3.h` file export EXQLITE_SYSTEM_CFLAGS=-I/usr/include # tell exqlite which sqlite implementation to use export EXQLITE_SYSTEM_LDFLAGS=-L/lib -lsqlite3 After exporting those variables you can then invoke mix deps.compile . Note if you re-export those values, you will need to recompile the exqlite dependency in order to pickup those changes. Database Encryption As of version 0.9, exqlite supports loading database engines at runtime rather than compiling sqlite3.c itself. This can be used to support database level encryption via alternate engines such as SQLCipher or the Official SEE extension . Once you have either of those projects installed on your system, use the following environment variables during compilation: # tell exqlite that we wish to use some other sqlite installation. this will prevent sqlite3.c and friends from compiling export EXQLITE_USE_SYSTEM=1 # Tell exqlite where to find the `sqlite3.h` file export EXQLITE_SYSTEM_CFLAGS=-I/usr/local/include/sqlcipher # tell exqlite which sqlite implementation to use export EXQLITE_SYSTEM_LDFLAGS=-L/usr/local/lib -lsqlcipher Once you have exqlite configured, you can use the :key option in the database config to enable encryption: config :exqlite , key : &quot; super - secret &#39;","ref":"readme.html#advanced-configuration"},{"type":"extras","title":"Readme - Usage","doc":"The Exqlite.Sqlite3 module usage is fairly straight forward. # We&#39;ll just keep it in memory right now { :ok , conn } = Exqlite.Sqlite3 . open ( &quot;:memory:&quot; ) # Create the table :ok = Exqlite.Sqlite3 . execute ( conn , &quot;create table test (id integer primary key, stuff text)&quot; ) # Prepare a statement { :ok , statement } = Exqlite.Sqlite3 . prepare ( conn , &quot;insert into test (stuff) values (?1)&quot; ) :ok = Exqlite.Sqlite3 . bind ( conn , statement , [ &quot;Hello world&quot; ] ) # Step is used to run statements :done = Exqlite.Sqlite3 . step ( conn , statement ) # Prepare a select statement { :ok , statement } = Exqlite.Sqlite3 . prepare ( conn , &quot;select id, stuff from test&quot; ) # Get the results { :row , [ 1 , &quot;Hello world&quot; ] } = Exqlite.Sqlite3 . step ( conn , statement ) # No more results :done = Exqlite.Sqlite3 . step ( conn , statement ) # Release the statement. # # It is recommended you release the statement after using it to reclaim the memory # asap, instead of letting the garbage collector eventually releasing the statement. # # If you are operating at a high load issuing thousands of statements, it would be # possible to run out of memory or cause a lot of pressure on memory. :ok = Exqlite.Sqlite3 . release ( conn , statement ) Using SQLite3 native extensions Exqlite supports loading run-time loadable SQLite3 extensions . A selection of precompiled extensions for popular CPU types / architectures is available by installing the ExSqlean package. This package wraps SQLean: all the missing SQLite functions . alias Exqlite.Basic { :ok , conn } = Basic . open ( &quot;db.sqlite3&quot; ) :ok = Basic . enable_load_extension ( conn ) # load the regexp extension - https://github.com/nalgeon/sqlean/blob/main/docs/re.md Basic . load_extension ( conn , ExSqlean . path_for ( &quot;re&quot; ) ) # run some queries to test the new `regexp_like` function { :ok , [ [ 1 ] ] , [ &quot;value&quot; ] } = Basic . exec ( conn , &quot;select regexp_like(&#39;the year is 2021&#39;, ?) as value&quot; , [ &quot;2021&quot; ] ) |&gt; Basic . rows ( ) { :ok , [ [ 0 ] ] , [ &quot;value&quot; ] } = Basic . exec ( conn , &quot;select regexp_like(&#39;the year is 2021&#39;, ?) as value&quot; , [ &quot;2020&quot; ] ) |&gt; Basic . rows ( ) # prevent loading further extensions :ok = Basic . disable_load_extension ( conn ) { :error , % Exqlite.Error { message : &quot;not authorized&quot; } , _ } = Basic . load_extension ( conn , ExSqlean . path_for ( &quot;re&quot; ) ) # close connection Basic . close ( conn )","ref":"readme.html#usage"},{"type":"extras","title":"Readme - Why SQLite3","doc":"I needed an Ecto3 adapter to store time series data for a personal project. I didn't want to go through the hassle of trying to setup a postgres database or mysql database when I was just wanting to explore data ingestion and some map reduce problems. I also noticed that other SQLite3 implementations didn't really fit my needs. At some point I also wanted to use this with a nerves project on an embedded device that would be resiliant to power outages and still maintain some state that ets can not afford.","ref":"readme.html#why-sqlite3"},{"type":"extras","title":"Readme - Under The Hood","doc":"We are using the Dirty NIF scheduler to execute the sqlite calls. The rationale behind this is that maintaining each sqlite's connection command pool is complicated and error prone.","ref":"readme.html#under-the-hood"},{"type":"extras","title":"Readme - Compiling NIF for Windows","doc":"When compiling on Windows, you will need the Build Tools or equivalent toolchain. Please make sure you have the correct environment variables, including path to compiler and linker and architecture that matches erl.exe (likely x64). You may also need to invoke vcvarsall.bat amd64 before running mix . A guide is available at guides/windows.md","ref":"readme.html#compiling-nif-for-windows"},{"type":"extras","title":"Readme - Contributing","doc":"Feel free to check the project out and submit pull requests.","ref":"readme.html#contributing"},{"type":"extras","title":"Windows users","doc":"Exqlite uses an Erlang NIF under the hood. Means calling a native implementation in C. For Windows users this means compiling Exqlite does not magically just work, in case it's not able to use the precompiled versions of SQLite (using advanced configuration - compile flags). Under the hood mix will try to compile the library with NMAKE on Windows. For this, NMAKE and C++ build tools needs to be available. Of course, using WSL 2 can be an alternative if things below doesn't work.","ref":"windows.html"},{"type":"extras","title":"Windows users - Requirements","doc":"Install Microsoft C++ Build Tools Download page: visualstudio.microsoft.com/visual-cpp-build-tools Alternative direct download link: aka.ms/vs/17/release/vs_buildtools.exe (aligned with Visual Studio 2022 - version 17) You need to install the Desktop development with C++ workload with probably the default optional components.","ref":"windows.html#requirements"},{"type":"extras","title":"Windows users - Building environment","doc":"Start command prompt with necessary environment Assuming you are building for Windows x64. Within Windows start menu search for: x64 Native Tools Command Prompt Starting this command prompt all necessary environment variables for compiling should be ready within the prompt. Ready to run: mix deps.compile exqlite # or mix compile mix test ... Alternative way to start prompt Assuming you have latest version of Build Tools, aligned with Visual Studio 2022 , installed in its default installation path. cmd /k &quot;C:\\Program Files (x86)\\Microsoft Visual Studio\\2022\\BuildTools\\VC\\Auxiliary\\Build\\vcvars64.bat&quot;","ref":"windows.html#building-environment"},{"type":"extras","title":"Windows users - Visual Studio Code users using ElixirLS","doc":"Assuming you have latest version of Build Tools, aligned with Visual Studio 2022 , installed in its default installation path. Start Visual Studio Code from a PowerShell prompt within your project folder. cmd /k '&quot;C:\\Program Files (x86)\\Microsoft Visual Studio\\2022\\BuildTools\\VC\\Auxiliary\\Build\\vcvars64.bat&quot; &amp;&amp; code .' With starting Visual Studio Code this way, ElixirLS should work and even your integrated terminal should be aware of the build tools. Probably make yourself a shortcut for this. Integrated terminal only Within your global settings.json or your workspace .vscode\\settings.json add: { &quot;terminal.integrated.shell.windows&quot;: &quot;cmd.exe&quot;, &quot;terminal.integrated.shellArgs.windows&quot;: [ &quot;/k&quot;, &quot;C:\\\\Program Files (x86)\\\\Microsoft Visual Studio\\\\2022\\\\BuildTools\\\\VC\\\\Auxiliary\\\\Build\\\\vcvars64.bat&quot; ] }","ref":"windows.html#visual-studio-code-users-using-elixirls"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - Unlreleased","doc":"","ref":"changelog.html#unlreleased"},{"type":"extras","title":"Changelog - v0.14.0","doc":"changed: Updated sqlite3 to 3.43.1 .","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"Changelog - v0.13.15","doc":"fixed: allow gnu compiled binaries to be included on the checksum update step. fixed: do not bind atoms that are prefixed with nil as NULL . https://github.com/elixir-sqlite/exqlite/pull/258","ref":"changelog.html#v0-13-15"},{"type":"extras","title":"Changelog - v0.13.14","doc":"fixed: OTP26 and Elixir 1.15 compilation issues.","ref":"changelog.html#v0-13-14"},{"type":"extras","title":"Changelog - v0.13.13","doc":"fixed: Check for null sqlite db connection.","ref":"changelog.html#v0-13-13"},{"type":"extras","title":"Changelog - v0.13.12","doc":"changed: Updated sqlite3 to 3.42.0 .","ref":"changelog.html#v0-13-12"},{"type":"extras","title":"Changelog - v0.13.11","doc":"fixed: Wrap include directory with string so it works with the compiler.","ref":"changelog.html#v0-13-11"},{"type":"extras","title":"Changelog - v0.13.10","doc":"added: Ability to specify :load_extensions for custom sqlite extensions. changed: Updated sqlite3 to 3.41.2 .","ref":"changelog.html#v0-13-10"},{"type":"extras","title":"Changelog - v0.13.9","doc":"fixed: Do not free mutex if it is not set.","ref":"changelog.html#v0-13-9"},{"type":"extras","title":"Changelog - v0.13.8","doc":"fixed: Handle SEGFAULT when trying to open a database that the application does not have permissions to open.","ref":"changelog.html#v0-13-8"},{"type":"extras","title":"Changelog - v0.13.7","doc":"added: precompilation support for musl based libc. changed: Updated sqlite to 3.41.1 .","ref":"changelog.html#v0-13-7"},{"type":"extras","title":"Changelog - v0.13.6","doc":"fixed: Error responses from sqlite NIF come back as an atom, the message field in Exqlite.Error is expected to be a string.","ref":"changelog.html#v0-13-6"},{"type":"extras","title":"Changelog - v0.13.5","doc":"changed: Allow :force_build to be specified in application configration to allow projects to force build the application rather than use precompiled binaries.","ref":"changelog.html#v0-13-5"},{"type":"extras","title":"Changelog - v0.13.4","doc":"changed: Updated sqlite3 to 3.41.0 .","ref":"changelog.html#v0-13-4"},{"type":"extras","title":"Changelog - v0.13.3","doc":"added: precompilation support.","ref":"changelog.html#v0-13-3"},{"type":"extras","title":"Changelog - v0.13.2","doc":"fixed: -O2 flag was not being set when compiling binaries in non windows environment.","ref":"changelog.html#v0-13-2"},{"type":"extras","title":"Changelog - v0.13.1","doc":"added: SQLITE_ENABLE_DBSTAT_VTAB=1 . changed: Allow EXQLITE_SYSTEM_CFLAGS to be appended to the CFLAGS regardless.","ref":"changelog.html#v0-13-1"},{"type":"extras","title":"Changelog - v0.13.0","doc":"removed: Remove support for Elixir 1.11 added: Support for custom pragmas to be set. changed: Updated sqlite3 to 3.40.1","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"Changelog - v0.12.0","doc":"changed: Use multi_step for Repo.stream calls. added: Ability to use URI for a database path. See sqlite docs . Example: file:/tmp/database.db?mode=ro .","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"Changelog - v0.11.9","doc":"fixed: step/2 typespec was specified incorrectly.","ref":"changelog.html#v0-11-9"},{"type":"extras","title":"Changelog - v0.11.8","doc":"changed: Updated sqlite3 to 3.40.0","ref":"changelog.html#v0-11-8"},{"type":"extras","title":"Changelog - v0.11.7","doc":"fixed: Segfault issue when database connections would time out.","ref":"changelog.html#v0-11-7"},{"type":"extras","title":"Changelog - v0.11.6","doc":"changed: Updated sqlite3 to 3.39.4","ref":"changelog.html#v0-11-6"},{"type":"extras","title":"Changelog - v0.11.5","doc":"changed: Updated sqlite3 to 3.39.3","ref":"changelog.html#v0-11-5"},{"type":"extras","title":"Changelog - v0.11.4","doc":"changed: Use sqlite3_open_v2 . changed: Expose :mode . changed: Removed old macro hack for erlang nifs.","ref":"changelog.html#v0-11-4"},{"type":"extras","title":"Changelog - v0.11.3","doc":"changed: Updated sqlite3 to 3.39.2","ref":"changelog.html#v0-11-3"},{"type":"extras","title":"Changelog - v0.11.2","doc":"changed: Fix incorrect ordering due to Enum.reverse/1 .","ref":"changelog.html#v0-11-2"},{"type":"extras","title":"Changelog - v0.11.1","doc":"changed: Updated sqlite3 to 3.38.5","ref":"changelog.html#v0-11-1"},{"type":"extras","title":"Changelog - v0.11.0","doc":"added: top level interface for Exqlite similar to Postgrex 's interface. added: optional table protocol support for results.","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"Changelog - v0.10.3","doc":"fixed: Improved fetch_all/4 call speed.","ref":"changelog.html#v0-10-3"},{"type":"extras","title":"Changelog - v0.10.2","doc":"changed: Updated sqlite3 to 3.38. revert: change made to Visual Studio 2022 vcvars64.bat","ref":"changelog.html#v0-10-2"},{"type":"extras","title":"Changelog - v0.10.1","doc":"fix: path to Visual Studio 2022 vcvars64.bat","ref":"changelog.html#v0-10-1"},{"type":"extras","title":"Changelog - v0.10.0","doc":"added: Custom memory allocator for sqlite to leverage erlang's enif_alloc functionality. This allows the memory usage to be tracked with the erlang vm usage stats.","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"Changelog - v0.9.3","doc":"fixed: SIGSEGV issue when a long running query is timed out.","ref":"changelog.html#v0-9-3"},{"type":"extras","title":"Changelog - v0.9.2","doc":"added: Ability to set :journal_size_limit in bytes. added: Ability to set :soft_heap_limit in bytes. added: Ability to set :hard_heap_limit in bytes.","ref":"changelog.html#v0-9-2"},{"type":"extras","title":"Changelog - v0.9.1","doc":"added: Documentation about compiling with system install sqlite3. fixed: Debug output during mix compile process.","ref":"changelog.html#v0-9-1"},{"type":"extras","title":"Changelog - v0.9.0","doc":"added: Allow setting :key option PRAGMA before all other pragmas to allow for use of encrypted sqlite databases.","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"Changelog - v0.8.7","doc":"added: Ability to compile exqlite using the system sqlite3 installation as opposed to building from source.","ref":"changelog.html#v0-8-7"},{"type":"extras","title":"Changelog - v0.8.6","doc":"changed: Compile SQLite3 with -DHAVE_USLEEP=1 to allow for more performant concurrent use.","ref":"changelog.html#v0-8-6"},{"type":"extras","title":"Changelog - v0.8.5","doc":"changed: Update SQLite from 3.37.0 to 3.37.2","ref":"changelog.html#v0-8-5"},{"type":"extras","title":"Changelog - v0.8.4","doc":"fixed: Improved typespecs.","ref":"changelog.html#v0-8-4"},{"type":"extras","title":"Changelog - v0.8.3","doc":"changed: Compilation output to be less verbose. If more verbosity is desired V=1 mix compile will remedy that. changed: When the path to the database does not exist, mkdir_p is invoked.","ref":"changelog.html#v0-8-3"},{"type":"extras","title":"Changelog - v0.8.2","doc":"fixed: unicode handling when preparing sql statements.","ref":"changelog.html#v0-8-2"},{"type":"extras","title":"Changelog - v0.8.1","doc":"fixed: unicode handling when executing sql statements.","ref":"changelog.html#v0-8-1"},{"type":"extras","title":"Changelog - v0.8.0","doc":"changed: Updated SQLite from 3.36.0 to 3.37.0 .","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"Changelog - v0.7.9","doc":"changed: Debug build opt in, instead of opt out. export DEBUG=yes before compilation and it will add a -g to the compilation process.","ref":"changelog.html#v0-7-9"},{"type":"extras","title":"Changelog - v0.7.3","doc":"added: support for static erlang compilation.","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"Changelog - v0.7.2","doc":"added: support for android compilation.","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"Changelog - v0.7.1","doc":"fixed: segfault on double closing an sqlite connection.","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"Changelog - v0.7.0","doc":"added: Exqlite.Basic for a simplified interface to utilizing sqlite3. added: ability to load sqlite extension.","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"Changelog - v0.6.4","doc":"changed: Updated SQLite from 3.35.5 to 3.36.0","ref":"changelog.html#v0-6-4"},{"type":"extras","title":"Changelog - v0.6.3","doc":"fixed: perceived memory leak for prepared statements not being cleaned up in a timely manner. This would be an issue for systems under a heavy load.","ref":"changelog.html#v0-6-3"},{"type":"extras","title":"Changelog - v0.6.2","doc":"changed: Handle only UTC datetime and convert them to iso form without offset.","ref":"changelog.html#v0-6-2"},{"type":"extras","title":"Changelog - v0.6.1","doc":"fixed: compilation issue on windows.","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"Changelog - v0.6.0","doc":"added: Exqlite.Sqlite3.serialize/2 to serialize the contents of the database to a binary. added: Exqlite.Sqlite3.deserialize/3 to load a previously serialized database from a binary.","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"Changelog - v0.5.11","doc":"changed: add the relevant sql statement to the Error exception message changed: update SQLite3 amalgamation to 3.35.5 fixed: issue with update returning nil rows for empty returning result.","ref":"changelog.html#v0-5-11"},{"type":"extras","title":"Changelog - v0.5.10","doc":"fixed: maybe_set_pragma was comparing upper case and lower case values when it should not matter.","ref":"changelog.html#v0-5-10"},{"type":"extras","title":"Changelog - v0.5.9","doc":"changed: Setting the pragma for Exqlite.Connection is now a two step process to check what the value is and then set it to the desired value if it is not already the desired value.","ref":"changelog.html#v0-5-9"},{"type":"extras","title":"Changelog - v0.5.8","doc":"added: Exqlite.Error now has the statement that failed that the error occurred on.","ref":"changelog.html#v0-5-8"},{"type":"extras","title":"Changelog - v0.5.7","doc":"changed: Update SQLite3 amalgamation to 3.35.4","ref":"changelog.html#v0-5-7"},{"type":"extras","title":"Changelog - v0.5.6","doc":"fixed: SQLite3 amalgamation in 0.5.5 being incorrectly downgraded to 3.34.1. Amalgamation is now correctly 3.35.3 .","ref":"changelog.html#v0-5-6"},{"type":"extras","title":"Changelog - v0.5.5","doc":"changed: Update SQLite3 amalgamation to version 3.35.3","ref":"changelog.html#v0-5-5"},{"type":"extras","title":"Changelog - v0.5.4","doc":"fixed: incorrect passing of chunk_size to fetch_all/4","ref":"changelog.html#v0-5-4"},{"type":"extras","title":"Changelog - v0.5.3","doc":"fixed: :invalid_chunk_size being emitted by the DBConnection.execute","ref":"changelog.html#v0-5-3"},{"type":"extras","title":"Changelog - v0.5.2","doc":"added: Guide for Windows users. added: Exqlite.Sqlite3.multi_step/3 to step through results chunks at a time. added: default_chunk_size configuration.","ref":"changelog.html#v0-5-2"},{"type":"extras","title":"Changelog - v0.5.1","doc":"changed: Bumped SQLite3 amalgamation to version 3.35.2 changed: Replaced old references of github.com/warmwaffles","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"Changelog - v0.5.0","doc":"removed: Ecto.Adapters.Exqlite . Replaced with Ecto Sqlite3 library.","ref":"changelog.html#v0-5-0"}]